package net.t2code.commandguiv2.Spigot.cmdManagement.register;


import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.objects.GuiObject;
import net.t2code.commandguiv2.Spigot.function.gui.OpenGUI;
import net.t2code.commandguiv2.Spigot.config.languages.SelectMessages;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class RegisterCommand extends Command {
    private String alias;

    public RegisterCommand(String alias) {
        super(alias);
        this.alias = alias;
    }

    @Override
    public boolean execute(CommandSender sender, String commandLabel, String[] args) {

        if (sender instanceof Player) {
            Player player = (Player) sender;
            GuiObject gui = Main.guiHashMap.get(alias);
            if (gui.guiEnable || player.hasPermission("commandgui.bypass")) {
                if (!gui.commandPermissionEnable || player.hasPermission("commandgui.command." + alias) || player.hasPermission("commandgui.bypass")) {
                    OpenGUI.openGUI(player, alias, true);
                } else T2Csend.player(player, SelectMessages.NoPermissionForCommand.replace("[cmd]", "/commandgui " + alias)
                        .replace("[perm]", "commandgui.command." + alias));
            } else T2Csend.player(player,SelectMessages.GUIIsDisabled.replace("[gui]", gui.guiName));
        } else sender.sendMessage("§8[§6Command§9GUI§8] §cThis command is only for players!");
        return true;
    }
}

