package net.t2code.commandguiv2.Spigot.function.useItem;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CLibConfig;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

public class ItemChange {
    public static void itemChange(Player player, Boolean setCursor) {
        Integer slot;
        if ((Boolean) Config.useItemInventorySlotEnforce.value) {
            slot =(Integer) Config.useItemInventorySlot.value;
        } else {
            slot = Events.useItemSlotHashMap.get(player.getName());
        }

        if (!(Boolean)Config.useItemEnable.value) {
            return;
        }
        UseItem.removeItem(player);
        if (UseItem.protection(player, false)) return;
        if ((Boolean)Config.useItemGiveOnlyOnFirstJoin.value) {
            if (!(Boolean)Config.useItemAllowToggle.value || Events.useItemHashMap.get(player.getName())) {
                if (!player.hasPlayedBefore()) {
                    new BukkitRunnable() {
                        @Override
                        public void run() {
                            UseItem.giveUseItem(player);
                            if (setCursor) {
                                setCursor(player, slot);
                            }
                        }
                    }.runTaskLater(Main.getPlugin(), 1L * 1);
                    if ((Boolean)Config.cursorToGUIItemOnlyOnFirstLogin.value ||(Boolean) Config.cursorToGUIItemOnLogin.value) {
                        player.getInventory().setHeldItemSlot(slot - 1);
                    }
                }
            }
            T2Csend.debug(Main.getPlugin(), "GiveOnlyOnFirstJoin: " + player.getName());
            return;
        }
        if (!(Boolean)Config.useItemGiveOnEveryJoin.value) {
            T2Csend.debug(Main.getPlugin(), "!GiveOnEveryJoin: " + player.getName());
            return;
        }
        new BukkitRunnable() {
            @Override
            public void run() {
                Boolean pln = Events.useItemHashMap.get(player.getName());
                if (pln == null) return;
                if (!(Boolean)Config.useItemAllowToggle.value || pln) {
                    if ((Boolean)Config.useItemInventorySlotEnforce.value || player.getInventory().getItem(slot - 1) == null) {
                        T2Csend.debug(Main.getPlugin(), "Give: " + player.getName());
                        UseItem.giveUseItem(player);
                        if (setCursor) {
                            setCursor(player, slot);
                        }
                    } else if ((Boolean)Config.useItemInventorySlotFreeSlot.value) {
                        boolean empty = false;
                        for (int i = 0; i < 9; i++) {
                            if (player.getInventory().getItem(i) == null) {
                                empty = true;
                                break;
                            }
                        }
                        if (empty) {
                            UseItem.addUseItem(player);
                        }
                    }
                }
            }
        }.runTaskLater(Main.getPlugin(), 1L * 1);
    }

    private static void setCursor(Player player, int slot) {
        T2Csend.debug(Main.getPlugin(), "setCursor 1 Player: " + player.getName());

        if (!(Boolean)Config.cursorToGUIItemOnLogin.value) {
            return;
        }
        T2Csend.debug(Main.getPlugin(), "setCursor 2 Player: " + player.getName());
        if ((Boolean)Config.cursorToGUIItemOnlyOnFirstLogin.value) {
            if (!player.hasPlayedBefore()) {
                player.getInventory().setHeldItemSlot(slot - 1);
                T2Csend.debug(Main.getPlugin(), "setCursor 3 Player: " + player.getName());
            }
            return;
        }
        T2Csend.debug(Main.getPlugin(), "setCursor 4 Player: " + player.getName());
        if (!T2CLibConfig.getBungee()) {
            player.getInventory().setHeldItemSlot(slot - 1);
            T2Csend.debug(Main.getPlugin(), "setCursor 5 Player: " + player.getName());
            return;
        }
        T2Csend.debug(Main.getPlugin(), "setCursor 6 Player: " + player.getName());
        if ((Boolean)Config.useItemServerChange.value) {
            player.getInventory().setHeldItemSlot(slot - 1);
            T2Csend.debug(Main.getPlugin(), "setCursor 7 Player: " + player.getName());
            return;
        }
        T2Csend.debug(Main.getPlugin(), "setCursor 8 Player: " + player.getName());
        T2Csend.debug(Main.getPlugin(), "setCursor bungeejoinplayers: " + Main.bungeejoinplayers);
        T2Csend.debug(Main.getPlugin(), "setCursor Player: " + player.getName());
        if (Main.bungeejoinplayers.contains(player.getName())) {
            player.getInventory().setHeldItemSlot(slot - 1);
            T2Csend.debug(Main.getPlugin(), "setCursor 9 Player: " + player.getName());
            Main.bungeejoinplayers.remove(player.getName());
        }
    }
}
