package net.t2code.commandguiv2.Spigot.database;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

import java.io.File;
import java.io.IOException;

public class YML {

    private static final Plugin plugin = Main.getPlugin();

    public static File storage = new File(Main.getPath(), "Storage/gui-item.yml");
    public static YamlConfiguration yamlConfigurationStorage = YamlConfiguration.loadConfiguration(storage);

    public static void setGuiItem(Player player, boolean status) {
        yamlConfigurationStorage.set(player.getUniqueId() + ".Playername", player.getName());
        yamlConfigurationStorage.set(player.getUniqueId() + ".Status", status);

        try {
            yamlConfigurationStorage.save(storage);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void setGuiitemSlot(Player player, Integer slot) {
        yamlConfigurationStorage.set(player.getUniqueId() + ".Playername", player.getName());
        yamlConfigurationStorage.set(player.getUniqueId() + ".Slot", slot);

        try {
            yamlConfigurationStorage.save(storage);
        } catch (IOException e) {
            Main.sendTryCatch(YML.class, e.getStackTrace()[0]);
            e.printStackTrace();
        }
    }

    public static Boolean selectGuiitemOn(Player player) {
        if (!yamlConfigurationStorage.contains(String.valueOf(player.getUniqueId()))) return true;
        return yamlConfigurationStorage.getBoolean(player.getUniqueId() + ".Status");
    }


    public static Integer selectSlot(Player player) {
        T2Csend.debug(plugin, "yml-1");
        if (!yamlConfigurationStorage.contains(String.valueOf(player.getUniqueId()))) return null;
        if (yamlConfigurationStorage.getString(player.getUniqueId() + ".Slot") == null) return null;
        T2Csend.debug(plugin, "yml-2");
        T2Csend.debug(plugin, String.valueOf(yamlConfigurationStorage.getInt(player.getUniqueId() + ".Slot")));
        return yamlConfigurationStorage.getInt(player.getUniqueId() + ".Slot");
    }
}
