package net.t2code.commandguiv2.Spigot.function.useItem;

import com.mojang.authlib.GameProfile;
import com.mojang.authlib.properties.Property;
import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Spigot.config.languages.SelectMessages;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.items.T2CitemVersion;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2CmcVersion;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.SkullMeta;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.UUID;

public class UseItem {
    public static void giveUseItem(Player player) {
        Integer slot;
        if (protection(player, false)) return;
        if ((Boolean) Config.useItemInventorySlotEnforce.value) {
            slot = (Integer) Config.useItemInventorySlot.value;
        } else {
            slot = Events.useItemSlotHashMap.get(player.getName());
        }
        if ((Boolean) Config.useItemInventorySlotFreeSlot.value) {
            player.getInventory().addItem(itemStack(player));
        } else {
            T2Csend.debug(Main.getPlugin(), "setUseItem: " + player.getName() + " Slot: " + Integer.parseInt(String.valueOf(slot - 1)));
            player.getInventory().setItem(slot - 1, itemStack(player));
        }
    }

    public static void addUseItem(Player player) {
        if (protection(player, false)) return;
        if ((Boolean) Config.useItemInventorySlotFreeSlot.value) {
            player.getInventory().addItem(itemStack(player));
        } else player.getInventory().addItem(itemStack(player));
    }

    private static ItemStack itemStack(Player player) {
        ItemStack item = null;
        if ((Boolean) Config.useItemPlayerHeadEnable.value) {
            if (T2CmcVersion.isMc1_8() || T2CmcVersion.isMc1_9() || T2CmcVersion.isMc1_10() || T2CmcVersion.isMc1_11() || T2CmcVersion.isMc1_12()) {
                T2Csend.player(player, Util.getPrefix() + "§c Playerheads for UseItem are only available from version §61.13§c!");
                T2Csend.error(Main.getPlugin(), "Playerheads for UseItem are only available from version 1.13!");
            } else {
                item = T2CitemVersion.getHeadIS();
                SkullMeta playerheadmeta = (SkullMeta) item.getItemMeta();
                playerheadmeta.setDisplayName(String.valueOf(Config.useItemName.value));
                if ((Boolean) Config.useItemBase64Enable.value) {
                    if (Main.PaPi) {
                        playerheadmeta.setLore(T2Creplace.replace(Util.getPrefix(), player, (ArrayList<String>) Config.useItemLore.value));
                    } else playerheadmeta.setLore(T2Creplace.replace(Util.getPrefix(), (ArrayList<String>) Config.useItemLore.value));
                    GameProfile profile = new GameProfile(UUID.randomUUID(), "");
                    profile.getProperties().put("textures", new Property("textures", String.valueOf(Config.useItemBase64value.value)));
                    Field profileField = null;
                    try {
                        profileField = playerheadmeta.getClass().getDeclaredField("profile");
                        profileField.setAccessible(true);
                        profileField.set(playerheadmeta, profile);
                    } catch (IllegalArgumentException | IllegalAccessException | NoSuchFieldException | SecurityException e) {
                        e.printStackTrace();
                    }
                } else {
                    String p;
                    if ((Boolean) Config.useItemPlayerWhoHasOpenedTheGUI.value) {
                        p = player.getName();
                    } else p = String.valueOf(Config.useItemPlayerName.value);
                    playerheadmeta.setOwner(p);
                    if (Main.PaPi) {
                        playerheadmeta.setLore(T2Creplace.replace(Util.getPrefix(), player, (ArrayList<String>) Config.useItemLore.value));
                    } else playerheadmeta.setLore(T2Creplace.replace(Util.getPrefix(), (ArrayList<String>) Config.useItemLore.value));
                }
                item.setItemMeta(playerheadmeta);
            }
        } else {
            item = new ItemStack(Material.valueOf(String.valueOf(Config.useItemMaterial.value)));
            ItemMeta itemMeta = item.getItemMeta();
            itemMeta.setDisplayName(String.valueOf(Config.useItemName.value));
            if (Main.PaPi) {
                itemMeta.setLore(T2Creplace.replace(Util.getPrefix(), player, (ArrayList<String>) Config.useItemLore.value));
            } else itemMeta.setLore(T2Creplace.replace(Util.getPrefix(), (ArrayList<String>) Config.useItemLore.value));
            item.setItemMeta(itemMeta);
            item.setAmount(1);
        }
        return item;
    }

    public static boolean protection(Player player, Boolean interact) {
        if ((Boolean) Config.useItemGameModeProtection.value) {
            if (String.valueOf(Config.useItemGameModeMode.value).equalsIgnoreCase("blacklist") && String.valueOf(Config.useItemGameModeList.value).contains(player.getGameMode().toString())) {
                if (interact) {
                    T2Csend.player(player, SelectMessages.UseItemDisabledInGameMode);
                } else if (!(Boolean) Config.useItemGameModeRemoveItemWhenItIsDisabled.value) removeItem(player);
                return true;
            }
            if (String.valueOf(Config.useItemGameModeMode.value).equalsIgnoreCase("whitelist") && !String.valueOf(Config.useItemGameModeList.value).contains(player.getGameMode().toString())) {
                if (interact) {
                    T2Csend.player(player, SelectMessages.UseItemDisabledInGameMode);
                } else if (!(Boolean) Config.useItemGameModeRemoveItemWhenItIsDisabled.value) removeItem(player);
                return true;
            }
        }
        if ((Boolean) Config.useItemWorldProtection.value) {
            if (String.valueOf(Config.useItemWorldMode.value).equalsIgnoreCase("blacklist") && String.valueOf(Config.useItemWorldList.value).contains(player.getWorld().getName())) {
                if (interact) {
                    T2Csend.player(player, SelectMessages.UseItemDisabledInWorld);
                } else if (!(Boolean) Config.useItemWorldRemoveItemWhenItIsDisabled.value) removeItem(player);
                return true;
            }
            if (String.valueOf(Config.useItemWorldMode.value).equalsIgnoreCase("whitelist") && !String.valueOf(Config.useItemWorldList.value).contains(player.getWorld().getName())) {
                if (interact) {
                    T2Csend.player(player, SelectMessages.UseItemDisabledInWorld);
                } else if (!(Boolean) Config.useItemWorldRemoveItemWhenItIsDisabled.value) removeItem(player);
                return true;
            }
        }
        return false;
    }

    public static void removeItem(Player player) {
        T2Csend.debug(Main.getPlugin(), "World disabled: " + player.getName() + " " + player.getWorld().toString());
        for (int iam = 0; iam < player.getInventory().getSize() - 5; iam++) {
            ItemStack itm = player.getInventory().getItem(iam);
            if (itm != null) {
                if (itm.getType() == Material.valueOf(String.valueOf(Config.useItemMaterial.value)) || itm.getType() == T2CitemVersion.getHead()) {
                    if (itm.getItemMeta().getDisplayName().equals(Config.useItemName.value)) {
                        player.getInventory().remove(itm);
                        player.updateInventory();
                        break;
                    }
                }
            }
        }
    }
}
